package net.roseindia.searchengine.action;

import net.roseindia.searchengine.model.*;
import net.roseindia.searchengine.dao.*;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.validator.annotations.*;

import java.util.*;
import java.text.*;
import javax.persistence.*;
import java.sql.*;
import javax.servlet.http.*; 
import org.springframework.web.context.support.*;
import org.springframework.web.context.*;


import java.io.StringWriter;

public class HibernateSearchAction extends ActionSupport{


    private int id;
    private int totalCount;
	private int startIndex=1;
	private int offSet= 5;
	private int perPage=5;
	private int totalPage;
	private int lastPageCount;
	private int searchCount;		
	
	private String title;
	private String url;
	private String pageContent;

	List totalPageList;
	List searchList;
	List searchPageList;

	Paging pageObj;

	
	 private SearchDao service;

	  public HibernateSearchAction(SearchDao service) {
	  this.service = service;
     }

	
    public int getId(){
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}

   
	
	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

   public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

    public String getPageContent() {
		return pageContent;
	}

	public void setPageContent(String pageContent) {
		this.pageContent = pageContent;
	}

	public int getStartIndex() {
		return startIndex;
	}

	public void setStartIndex(int startIndex) {
		this.startIndex = startIndex;
	}

	public int getOffSet() {
		return offSet;
	}

	public void setOffSet(int offSet) {
		this.offSet = offSet;
	}

   public int getTotalCount() {
		return totalCount;
	}

	public void setTotalCount(int totalCount) {
		this.totalCount = totalCount;
	}

  public int getLastPageCount() {
		return lastPageCount;
	}

	public void setLastPageCount(int lastPageCount) {
		this.lastPageCount = lastPageCount;
	}
	public List getSearchList(){
		return searchList;
	}

	public List getSearchPageList(){
		return searchPageList;
	}


	public List getTotalPageList(){
		return totalPageList;
	}



     public int getSearchCount(){
		return searchCount;
	}
	 
	public String doInput() throws Exception {
			return INPUT;
	}



		public String save() throws SQLException {
			Webpages webpages =  new Webpages();
			webpages.setTitle(title);
			webpages.setUrl(url);
			webpages.setPageContent(pageContent);
			try
			{
			service.save(webpages);
			}
			catch (Exception e) {
			//System.out.println("SQLException Error is:" + e.getMessage());
			}
			return SUCCESS;
		}

		public String searchIndex()throws Exception{
			if(title!=null && title!="")
			{
			HttpServletRequest httpServletRequest  = (HttpServletRequest) ActionContext.getContext().get(org.apache.struts2.StrutsStatics.HTTP_REQUEST);
			totalPageList = new ArrayList();
			startIndex = startIndex*offSet-offSet;
			pageObj = service.searchPageObj(title,startIndex,offSet);
			searchPageList = pageObj.getSearchList();
			httpServletRequest.setAttribute("title",title);
			httpServletRequest.setAttribute("searchPageList",searchPageList);
			searchCount = pageObj.getTotalCount();
			httpServletRequest.setAttribute("totalcount",searchCount);
			setTotalCount(pageObj.getTotalCount());
			if(searchCount%perPage==0)
			{
			totalPage = searchCount/perPage;
			}
			else
			{
			totalPage = searchCount/perPage+1;
			}
			for(int i=0;i<totalPage;i++)
			{
			totalPageList.add(i);
			}
			httpServletRequest.setAttribute("totalPage",totalPage);
			setLastPageCount(totalPageList.size());
			return SUCCESS;
			}
			else
			{
				return ERROR;
			}
		}

}

